<?php

use Tygh\Registry;

if (!defined('BOOTSTRAP')) {
    die('Access denied');
}


if (defined('PAYMENT_NOTIFICATION')) {
    
    if(isset($_GET['order_id'])){
        
        fn_order_placement_routines('route', $_GET['order_id']);
        
    }else{
        
        $order_id = $_POST['PAYMENT_ID'];
        $payment_id = db_get_field("SELECT payment_id FROM ?:orders WHERE order_id = ?i", $order_id);
        $processor_data = fn_get_payment_method_data($payment_id);

        $string =
                $_POST['PAYMENT_ID'] . ':' . $_POST['PAYEE_ACCOUNT'] . ':' .
                $_POST['PAYMENT_AMOUNT'] . ':' . $_POST['PAYMENT_UNITS'] . ':' .
                $_POST['PAYMENT_BATCH_NUM'] . ':' .
                $_POST['PAYER_ACCOUNT'] . ':' . strtoupper(md5($processor_data['processor_params']['alternate_passphrase'])) . ':' .
                $_POST['TIMESTAMPGMT'];

        $hash = strtoupper(md5($string));

        $order_info = fn_get_order_info($order_id);

        if ($_POST['V2_HASH'] === $hash) { // hash checking
            if ($_POST['PAYMENT_AMOUNT'] == $order_info['total'] && $_POST['PAYEE_ACCOUNT'] == $processor_data['processor_params']['payee_account']) {

                // some code to confirm payment
                $pp_response = array();
                $pp_response['order_status'] = 'P';
                $pp_response['reason_text'] = 'status_url';
                $pp_response['transaction_id'] = $_POST['PAYMENT_BATCH_NUM'];
                fn_finish_payment($order_id, $pp_response, false);
            }
        }
        
    }
    
} else {

    $_order_id = ($order_info['repaid']) ? ($order_id . '_' . $order_info['repaid']) : $order_id;

    $payment_id = db_get_field("SELECT payment_id FROM ?:orders WHERE order_id = ?i", $_order_id);
    $processor_data = fn_get_payment_method_data($payment_id);
    $order_info = fn_get_order_info($_order_id);
    $store_name = fn_get_company_name($order_info['company_id']);
    $currency_code = ($processor_data['processor_params']['payee_account'][0] == 'U') ? 'USD' : (($processor_data['processor_params']['payee_account'][0] == 'E') ? 'EUR' : '');
    $status_url = fn_url('payment_notification.notify?payment=perfectmoney');
    $payment_url = fn_url('payment_notification.process?payment=perfectmoney&order_id='.$_order_id);
    $nopayment_url = fn_url('checkout.cart');
    
    echo '<html>
		<body onLoad="javascript: document.process.submit();">
			<form action="https://perfectmoney.is/api/step1.asp" method="POST" name="process" />
				<input type="hidden" name="PAYEE_ACCOUNT" value="' . $processor_data['processor_params']['payee_account'] . '" />
				<input type="hidden" name="PAYEE_NAME" value="' . $store_name . '" />
				<input type="hidden" name="PAYMENT_AMOUNT" value="' . $order_info['total'] . '" />
				<input type="hidden" name="PAYMENT_UNITS" value="' . $currency_code . '" />
				<input type="hidden" name="STATUS_URL" value="' . $status_url . '" />
				<input type="hidden" name="PAYMENT_URL" value="' . $payment_url . '" />
				<input type="hidden" name="PAYMENT_URL_METHOD" value="LINK" />
				<input type="hidden" name="NOPAYMENT_URL" value="' . $nopayment_url . '" />
				<input type="hidden" name="NOPAYMENT_URL_METHOD" value="LINK" />
				<input type="hidden" name="PAYMENT_ID" value="' . $_order_id . '" />
			</form>
		</body>
	</html>';

    exit;
}
?>